--[[=============================================================================
    Main script file for driver

    Copyright 2016 Control4 Corporation. All Rights Reserved.
===============================================================================]]
require "common.c4_driver_declarations"
require "common.c4_common"
require "common.c4_init"
require "common.c4_property"
require "common.c4_command"
require "common.c4_notify"
require "common.c4_utils"
require "lib.c4_timer"
require "actions"
require "device_specific_commands"
require "device_messages"
require "proxy_init"
require "properties"
require "proxy_commands"
require "connections"

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.driver = "2016.01.08"
end

--[[=============================================================================
    Initialization Code
===============================================================================]]
function ON_DRIVER_EARLY_INIT.main()
	
end

function ON_DRIVER_INIT.main()
	-- TODO: Change the logger name
	SetLogName("Camera_c4z")

	-- TODO: If cloud based driver then uncomment the following line
	--ConnectURL()
end

function ON_DRIVER_LATEINIT.main()
	--C4:urlSetTimeout (20)
	local ip = C4:GetBindingAddress(6001)
	if (ip ~= nil and string.len(ip) > 0) then OnNetworkBindingChanged(6001, true) end
	if (ip ~= nil and string.len(ip) > 0)  then C4:SetBindingStatus(6001, "online") end
end

--[[
	This will be called by the base template code from its OnDriverUpdate function.
]]--
function ON_DRIVER_UPDATE.Camera()
	OnDriverInit()
end
